const path = require('path');
const { parse } = require('scss-parser');

let { version } = require(path.resolve(__dirname, '../../package.json'));

module.exports = info => $ => {
  // Remove comments
  $()
    .find(/comment/)
    .remove();
  // Remove extra new lines
  $()
    .find('space')
    .filter(n => {
      return /^\n{2}/.test(n.node.value);
    })
    .replace(n => {
      return {
        type: 'space',
        value: n.node.value.replace(/\n{2,}(\s*)/, '\n$1')
      };
    });
  // Insert an info comment
  let message = [
    '/*',
    `design-system-internal ${info.version} (${info.sha})`,
    `scss-parser-aura ${version}`,
    '',
    'This file is automatically generated.',
    'Please do not edit or check in changes to this file.',
    'If you need changes made, please contact the Aura Styling Platform team.',
    '*/'
  ].join('\n');
  $()
    .children()
    .eq(0)
    .before(parse(message).value[0])
    .before({ type: 'space', value: '\n' });
};
